/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rjdkolb.testentities;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author richard
 */
@Entity
@Table(name = "DATA_TYPE_DEFINITION")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "DataTypeDefinition.findAll", query = "SELECT d FROM DataTypeDefinition d"),
    @NamedQuery(name = "DataTypeDefinition.findByColName", query = "SELECT d FROM DataTypeDefinition d WHERE d.colName = :colName"),
    @NamedQuery(name = "DataTypeDefinition.findByOracleDataType", query = "SELECT d FROM DataTypeDefinition d WHERE d.oracleDataType = :oracleDataType"),
    @NamedQuery(name = "DataTypeDefinition.findByDataTypeCode", query = "SELECT d FROM DataTypeDefinition d WHERE d.dataTypeDefinitionPK.dataTypeCode = :dataTypeCode"),
    @NamedQuery(name = "DataTypeDefinition.findByColNum", query = "SELECT d FROM DataTypeDefinition d WHERE d.dataTypeDefinitionPK.colNum = :colNum")})
public class DataTypeDefinition implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected DataTypeDefinitionPK dataTypeDefinitionPK;
    @Column(name = "COL_NAME", length = 30)
    private String colName;
    @Column(name = "ORACLE_DATA_TYPE", length = 16)
    private String oracleDataType;
    @JoinColumn(name = "DATA_TYPE_CODE", referencedColumnName = "DATA_TYPE_CODE", nullable = false, insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private DataType dataType;

    public DataTypeDefinition() {
    }

    public DataTypeDefinition(DataTypeDefinitionPK dataTypeDefinitionPK) {
        this.dataTypeDefinitionPK = dataTypeDefinitionPK;
    }

    public DataTypeDefinition(String dataTypeCode, int colNum) {
        this.dataTypeDefinitionPK = new DataTypeDefinitionPK(dataTypeCode, colNum);
    }

    public DataTypeDefinitionPK getDataTypeDefinitionPK() {
        return dataTypeDefinitionPK;
    }

    public void setDataTypeDefinitionPK(DataTypeDefinitionPK dataTypeDefinitionPK) {
        this.dataTypeDefinitionPK = dataTypeDefinitionPK;
    }

    public String getColName() {
        return colName;
    }

    public void setColName(String colName) {
        this.colName = colName;
    }

    public String getOracleDataType() {
        return oracleDataType;
    }

    public void setOracleDataType(String oracleDataType) {
        this.oracleDataType = oracleDataType;
    }

    public DataType getDataType() {
        return dataType;
    }

    public void setDataType(DataType dataType) {
        this.dataType = dataType;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (dataTypeDefinitionPK != null ? dataTypeDefinitionPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DataTypeDefinition)) {
            return false;
        }
        DataTypeDefinition other = (DataTypeDefinition) object;
        if ((this.dataTypeDefinitionPK == null && other.dataTypeDefinitionPK != null) || (this.dataTypeDefinitionPK != null && !this.dataTypeDefinitionPK.equals(other.dataTypeDefinitionPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "za.co.enerweb.test.testentities.DataTypeDefinition[ dataTypeDefinitionPK=" + dataTypeDefinitionPK + " ]";
    }

}
